// xsetaseta@gmail.com
// Lector de sensor de temperatura externa Modelo 40170
// Sensor BMP180
// 25/11/2022
// arduino 1.8.13

#define DEBUG
//#define VERDATA   //Ver valores
//#define VERLOGI   //Ver binarios
//#define VERTEST   //Ver valores de ajuste

//Tiempos ------------
#define BIT_INICIO 78
#define BIT1 39
#define BIT0 19

#define BIT1a  BIT1-1
#define BIT1b  BIT1+1
#define BIT0a  BIT0-1
#define BIT0b  BIT0+1
#define BIT_INICIOa BIT_INICIO-2
#define BIT_INICIOb BIT_INICIO+2

#define NUMBIT 28
#define IDATA1  6
#define IDATA2  11
#define IDATA3  23
#define IDATA4  25

#define IN_READ 2

int canal;
int grados;
int humedad;
int bateria,byte1,byte2;
char CheckSum;

unsigned long time,timeU,timeM,diferencia;
int Adiferencia;
bool estadoDato;
unsigned  NumBit;
char datos[50];

int z;
bool ledState;

//----BMP180-------------------------
#include <Wire.h>

#define BMP180_ADDR 0x77 // 7-bit address

#define  BMP180_REG_CONTROL 0xF4
#define BMP180_REG_RESULT 0xF6
#define BMP180_COMMAND_TEMPERATURE 0x2E

int AC1,AC2,AC3,VB1,VB2,MB,MC,MD;
unsigned int AC4,AC5,AC6; 
unsigned char _error;

long Temperatura,Presion,PresionBase;
unsigned char mibufferU[10];
char mibuffer[20];

// altura en Palencia -SPAIN
#define ALTURA 790

//-------------------------------------


//---Interrupcion--------------
void InumPasos()
{
  time=micros();         
  diferencia=time-timeU;
  Adiferencia=diferencia>>7;
  estadoDato=1; 
salto: 
  timeU=time; 
}
//-----------------------------

char clave[] = "SENSORTOTAL5";

void setup() 
{
  Serial.begin(9600);
  //Serial.println("Int433_Mode40170_BMP180");
  for (char zx = 0; zx < 4; zx++) { Serial.println(clave); delay(300); } 
  
  pinMode(IN_READ, INPUT);
  attachInterrupt(digitalPinToInterrupt(IN_READ), InumPasos, RISING);
  pinMode(13,OUTPUT);

    startBMP180();
    getBMP180();
    PresionBase=Presion;   
    Serial.print("Presion base: ");
    Serial.print(PresionBase);
    Serial.println(" mb");  
}

void loop() 
{
  if(estadoDato==1)
   {     
     estadoDato=0;
     if(Adiferencia>15 && Adiferencia<100)
       { 
        #ifdef VERTEST
          Serial.println(Adiferencia,DEC);
        #else
        if(Adiferencia>=BIT0a && Adiferencia<=BIT0b)
          { 
            #ifdef VERDATA           
              Serial.print(Adiferencia,DEC);
            #endif
            #ifdef VERLOGI
              Serial.print("0");
            #endif
            datos[NumBit]=0;
            if(NumBit<40) NumBit++;
            goto saltox;
          }
          
        if(Adiferencia>BIT1a && Adiferencia<BIT1b)
          { 
            #ifdef VERDATA         
              Serial.print(Adiferencia,DEC);
            #endif
            #ifdef VERLOGI
              Serial.print("1");
            #endif
            datos[NumBit]=1;
            if(NumBit<40) NumBit++;  
            goto saltox;
          } 
          
        if(Adiferencia>BIT_INICIOa && Adiferencia<BIT_INICIOb)
            { 
              #ifdef VERLOGI
                Serial.print("####"); Serial.println(NumBit,DEC); 
              #endif
              #ifdef VERDATA                  
                Serial.println(Adiferencia,DEC);
              #endif
              
              if(NumBit==NUMBIT) 
                {
                  Serial.println("INICIO");
                  getDatos();    
                  if(getBMP180()){  Serial.print("ERRORES=");  Serial.println(_error);}

                  Serial.print("Canal="); Serial.println(canal,DEC);
                  intTOstring(grados,5,1);  
                  Serial.print("Grados=");Serial.println(mibuffer);
                  intTOstring(Temperatura,5,2);  
                  Serial.print("BMP1="); Serial.println(mibuffer);
                  z=Presion/100;
                  intTOstring(z,5,0); 
                  Serial.print("BMP2="); Serial.println(mibuffer);
                  Serial.print("CHECKSUM=");   Serial.println(CheckSum,DEC);  
                  Serial.println("FINAL\n");
                  
                }
              NumBit=0;
              goto saltox;
            }
        #endif
       }
       
   }
saltox:       

//-------Parpadeo------
   time=millis();
   z=time-timeM;
   if(z>1000)
    {
      if (ledState == LOW) { ledState = HIGH; } else { ledState = LOW;  }
      digitalWrite(13, ledState);
      timeM=time;
    }
//---------------------      
      
}



void getDatos(void)
{
  int z,zz,i;
  unsigned char Dbyte[4];
  int checksum_rx,checksum;
  
             i=0;   CheckSum=0;
              for(zz=0;zz<4;zz++)
                  {  
                    Dbyte[zz]=0;
                    for(z=0;z<8;z++)
                      {
                        Dbyte[zz]<<=1;
                        if(datos[i]==1) { Dbyte[zz]|=1; }                        
                        i++;
                      }
                  }
                  checksum_rx = ((Dbyte[0] & 0xF0) >> 4);
                  checksum = ((Dbyte[0] & 0x0F) +
                  (Dbyte[1] >> 4) +  (Dbyte[1] & 0x0F) +
                  (Dbyte[2] >> 4) +  (Dbyte[2] & 0x0F) +
                  (Dbyte[3] >> 4) - 1);
                  checksum &= 0x0F;
                  if(checksum_rx==checksum) CheckSum=1;
           #ifdef VERLOGI
                  Serial.print("checksum_rx=");  Serial.println(checksum_rx);
                  Serial.print("checksum=");  Serial.println(checksum);
           #endif 
  
           #ifdef VERLOGI
                    for(z=0;z<NUMBIT;z++) 
                      {
                        Serial.print(datos[z],DEC);
                        if(z==IDATA1 || z==IDATA2 || z==IDATA3 || z==IDATA4) Serial.print(" ");
                      } 
                    Serial.println("<-");
           #endif       
                     grados=0;
                     for(z=12;z<24;z++)
                      {
                        grados<<=1;
                        if(datos[z]==1)grados|=1;
                      }                     
                     canal=0;
                     for(z=24;z<26;z++)
                      {
                        canal<<=1;
                        if(datos[z]==1)canal|=1;
                      }
                     bateria=0;
                     for(z=7;z<12;z++)
                      {
                        bateria<<=1;
                        if(datos[z]==1)bateria|=1;
                      }

                     byte1=0;
                     for(z=0;z<=6;z++)
                      {
                        byte1<<=1;
                        if(datos[z]==1)byte1|=1;
                      }
                     byte2=0;
                     for(z=26;z<=27;z++)
                      {
                        byte2<<=1;
                        if(datos[z]==1)byte2|=1;
                      }
                    
                 #ifdef VERLOGI
                     Serial.print(grados,BIN);  Serial.print(" ");
                     Serial.print(canal,BIN);  Serial.print(" "); 
                     Serial.print(bateria,BIN);  Serial.print(" "); 
                     Serial.print(byte1,BIN);Serial.print(" "); 
                     Serial.println(byte2,BIN);             
                 #endif
                     
                     // Grados negativos
                     if( (grados&2048)==2048)
                      {                       
                        grados=grados-4096;
                      }
                     /*
                     Serial.print("Grados="); Serial.println(grados,DEC);
                     Serial.print("Bateria="); Serial.println(bateria,DEC);
                     Serial.print("byte1="); Serial.println(byte1,DEC);
                     Serial.print("byte2="); Serial.println(byte2,DEC)
                     Serial.print("checksum=");   Serial.println(CheckSum,DEC);
                     */
}



//_SETA43_____

int MiLecturaI(char address)
{
 char x;
  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(address);
  if(Wire.endTransmission()) Serial.print("ERROR ");
  
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++)  mibufferU[x] = Wire.read();
  return( (((int)mibufferU[0]<<8)|(int)mibufferU[1]) ); 
}  


char startBMP180(void)
{
  Wire.begin();      
  AC1=MiLecturaI(0xAA);
  AC2=MiLecturaI(0xAC);
  AC3=MiLecturaI(0xAE);
  AC4=MiLecturaI(0xb0);
  AC5=MiLecturaI(0xb2);
  AC6=MiLecturaI(0xb4);
  VB1=MiLecturaI(0xb6);
  VB2=MiLecturaI(0xb8);
  MB=MiLecturaI(0xba);
  MC=MiLecturaI(0xbc);
  MD=MiLecturaI(0xbe);
}


char getBMP180(void)
{
  char x;
  long x1,x2,x3,mtu,mpu,b5,b6,b3,p;
  unsigned long b4,b7;
  
  _error=0;
   
  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = BMP180_COMMAND_TEMPERATURE;  
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(20);
  
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,2);
  while(Wire.available() != 2) ; 
  for(x=0;x<2;x++) mibufferU[x] = Wire.read();
  mtu = mibufferU[0];
  mtu=mtu<<8;
  mtu+=mibufferU[1];  //UT
//Serial.print("mtu=");Serial.print(mtu);

  mibufferU[0] = BMP180_REG_CONTROL;
  mibufferU[1] = 0x34;  //oss=0
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU,2);
  if(Wire.endTransmission()) _error++;
  delay(26);
  mibufferU[0] = BMP180_REG_RESULT;
  Wire.beginTransmission(BMP180_ADDR);
  Wire.write(mibufferU[0]);
  if(Wire.endTransmission()) _error++;
  Wire.requestFrom(BMP180_ADDR,3);
  while(Wire.available() != 3) ; 
  for(x=0;x<3;x++) mibufferU[x] = Wire.read();  
 // for(x=0;x<3;x++) Serial.println(mibufferU[x]);  
  mpu = mibufferU[0];
  mpu=mpu<<16;
  x1=mibufferU[1];
  x1=x1<<8;
  mpu+=x1;
  mpu+=mibufferU[1];
  mpu=mpu>>8;  //oss=0    UP
//  Serial.print("   mpu=");Serial.println(mpu);
     
  x1=mtu-AC6;  x1*=AC5;  x1=x1>>15;
  x2=MC;  x2=x2<<11;  x2/=(x1+MD);
  x1+=x2;
  b5=x1;
  x1+=8;
  x1*=10;
  Temperatura=x1>>4;
  

  b6=b5-4000;
  x1=b6*b6;  x1=x1>>12;  x1=x1*VB2;  x1=x1>>11;
  x2=AC2;  x2=x2*b6; x2=x2>>11;
  x3=x2+x1;
  b3=AC1; b3=b3<<2; b3=b3+x3; b3=b3+2; b3=b3>>2;
  x1=AC3; x1*=b6;  x1=x1>>13;
  x2=b6*b6; x2=x2>>12; x2=x2*VB1; x2=x2>>16;
  x3=x1+x2;  x3=x3+2; x3=x3>>2;
  b4=x3;  b4=b4+32768;  b4=b4*AC4;  b4=b4>>15;
  b7=mpu-b3;  b7=b7*50000;
  if(b7<0x80000000)
    {
      p=b7; p=p<<1; p=p/b4;
    }
    else
    {
      p=b7/b4;  p=p<<1;
    }
  x1=p;  x1=x1>>8;  x1=x1*x1;
  x1=x1*3038;  x1=x1>>16;
  x2=-7357;  x2*=p;  x2=x2>>16;
  x1+=x2;  x1=x1+3791; x1=x1>>4;  p+=x1; 
  Presion=p;
  
return(_error);   
}


//_SETA43__
void intTOstring(int n,unsigned char dig,unsigned char dec)
{
  int z,x,zz;
  char signo;

  zz=0;
  z=10000;
  if(n<0) { signo='-'; n*=-1;}  else  {signo='+'; }
  mibuffer[zz]=signo; zz++;
  for(;z>0;z=z/10)
  {
    x=n/z;
    n=n-(z*x);
    mibuffer[zz]=x+'0';
    zz++;
  }
  mibuffer[zz]=0;
  
  if(dec!=0)
   {
    x=zz+1;
    for(;zz>=0;zz--)
    {
    mibuffer[x]=mibuffer[zz];
    x--;
    if(0==dec) { mibuffer[x]='.'; x--;} 
    dec--;
    }
   }
}
